<?php

namespace Wp618\Backend;

if ( !defined( 'ABSPATH' ) ) exit;

class Plugin_install{
    //
    public function __construct($file)
    {
        register_activation_hook( $file, [__CLASS__, 'cb_activation']);
        register_deactivation_hook( $file, [__CLASS__, 'cb_deactivation']);
        register_uninstall_hook( $file, [__CLASS__, 'cb_uninstall']);
    }

    //
    public static function cb_activation(){
        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();

        $app = App::getInstance();
        $app->visitor_model->load_dbDelta();

        $table =  $app->visitor_model->get_table();;
        $sql = "CREATE TABLE IF NOT EXISTS {$table}(
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip` varchar(15) CHARACTER SET utf8mb4 NOT NULL,
  `http_code` smallint(6) NOT NULL,
  `request_method` varchar(15) CHARACTER SET utf8mb4 NOT NULL,
  `lang` varchar(127) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `ua` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `page_type` varchar(15) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `time_ms` int(11) NOT NULL,
  `referer` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `crtime` datetime NOT NULL,
  `uptime` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ip` (`ip`)
) {$charset_collate}";
        \dbDelta($sql);
    }

    //
    public static function cb_deactivation(){

    }

    //
    public static function cb_uninstall(){

    }

}
